DROP TABLE DOLGOZ;

CREATE TABLE DOLGOZ AS
    SELECT * FROM EMP;

SELECT * FROM DOLGOZ;



CREATE OR REPLACE PROCEDURE FONOK(F IN DOLGOZ.MGR%TYPE)
    IS
    DARAB INTEGER;
BEGIN
    SELECT COUNT(*) INTO DARAB
    FROM DOLGOZ
    WHERE MGR=F;

    IF DARAB=0 THEN
        RAISE_APPLICATION_ERROR(-20154, 'HIBA: A MEGADOTT FNK NEM LTEZIK!');
    ELSE
        DBMS_OUTPUT.PUT_LINE('A MEGADOTT FNK LTEZIK.');
    END IF;
END;
/
    
    
    
CREATE OR REPLACE PROCEDURE FIZETES(FONOK IN DOLGOZ.MGR%TYPE, FIZ IN DOLGOZ.SAL%TYPE, RESZL IN DOLGOZ.DEPTNO%TYPE)
    IS
    DARAB INTEGER;
    ATLFIZ DOLGOZ.SAL%TYPE;
BEGIN
    SELECT COUNT(*) INTO DARAB
    FROM DOLGOZ
    WHERE DEPTNO=RESZL;

    IF DARAB=0 THEN
        DBMS_OUTPUT.PUT_LINE('A MEGADOTT RSZLEG NEM LTEZIK.');
        
        SELECT AVG(SAL) INTO ATLFIZ FROM DOLGOZ
        WHERE MGR=FONOK;

        IF FIZ>=ATLFIZ THEN
            DBMS_OUTPUT.PUT_LINE('A MEGADOTT FIZETS MEGFELEL.');
        ELSE
            RAISE_APPLICATION_ERROR(-20222, 'HIBA: A MEGADOTT FIZETS TL KEVS!');
        END IF;
    ELSE
        DBMS_OUTPUT.PUT_LINE('A MEGADOTT RSZLEG LTEZIK.');
        
        SELECT AVG(SAL) INTO ATLFIZ FROM DOLGOZ
        WHERE DEPTNO=RESZL;

        IF FIZ>=ATLFIZ THEN
            DBMS_OUTPUT.PUT_LINE('A MEGADOTT FIZETS MEGFELEL.');
        ELSE
            RAISE_APPLICATION_ERROR(-20223, 'HIBA: A MEGADOTT FIZETS TL KEVS!');
        END IF;
    END IF;
END;
/
    
    
    
DROP TRIGGER BESZURAS;

CREATE OR REPLACE TRIGGER BESZURAS
    BEFORE INSERT ON DOLGOZ
    FOR EACH ROW
BEGIN
    DBMS_OUTPUT.PUT_LINE('ADJA MEG AZ J DOLGOZ NEVT! ' || :NEW.ENAME);
    FONOK(:NEW.MGR);
    FIZETES(:NEW.MGR, :NEW.SAL, :NEW.DEPTNO);
    DBMS_OUTPUT.PUT_LINE(:NEW.ENAME || ' FELVTELE OK!');
END;
/
    
    
-- TESZTESETEK
-- A MEGADOTT FNK NEM LTEZIK (1. ESET)
INSERT INTO DOLGOZ VALUES
(1111, 'GZA1', 'UDVAROS', 7990, SYSDATE, 500, NULL, 10);

-- A MEGADOTT FNK LTEZIK, A MEGADOTT RSZLEG NEM LTEZIK S A MEGADOTT FIZETS MEGFELEL (2. ESET)
INSERT INTO DOLGOZ VALUES
(1112, 'GZA2', 'MANAGER', 7839, SYSDATE, 3000, NULL, 90);

-- A MEGADOTT FNK LTEZIK, A MEGADOTT RSZLEG NEM LTEZIK S A MEGADOTT FIZETS TL KEVS (3. ESET)
INSERT INTO DOLGOZ VALUES
(1112, 'GZA3', 'MANAGER', 7839, SYSDATE, 900, NULL, 90);

-- A MEGADOTT FNK LTEZIK, A MEGADOTT RSZLEG LTEZIK S A MEGADOTT FIZETS MEGFELEL (4. ESET)
INSERT INTO DOLGOZ VALUES
(1113, 'GZA4', 'SALESMAN', 7839, SYSDATE, 2000, NULL, 30);

-- A MEGADOTT FNK LTEZIK, A MEGADOTT RSZLEG LTEZIK S A MEGADOTT FIZETS TL KEVS (5. ESET)
INSERT INTO DOLGOZ VALUES
(1113, 'GZA5', 'SALESMAN', 7839, SYSDATE, 1000, NULL, 30);


SELECT * FROM DOLGOZ;


ROLLBACK;